#include "allegro_color.h"
#include "cart.h"
#include "sprite.h"
#include "game.h"

CART::CART()
{
	mobile = NULL;
	turret = NULL;
	gun = NULL;
	x = 0;
	y = 0;
	//xspeed = 0;
	//yspeed = 0;
	bImage = NULL;
	angle = 0;
	MODE = 0;
	engine = false;
	engine_delay = 0;
	engine_speed = 0.0;
	max_speed = 0;
}

CART::~CART()
{

}

void CART::load(int color)
{
	mobile = new SPRITE;
	turret = new SPRITE;
	gun = new SPRITE;

	
	mobile->load("Cart.bmp", 32, 32, 2);
	turret->load("turret.bmp", 32, 32, 8);
	gun->load("Gun.bmp", 32, 32, 1);

	bImage = create_bitmap(mobile->bImage->w, mobile->bImage->h);
	clear(bImage);

	alignment = VERTICAL;
	facing = DOWN;
}

void CART::draw()
{
	rectfill(bImage, 0, 0, bImage->w, bImage->h, makecol(255, 0, 255));
	if(alignment == HORIZONTAL)
		mobile->xcurframe = 1;
	else
		mobile->xcurframe = 0;
	mobile->get_frame();
	draw_sprite(bImage, mobile->bImage, 0, 0);

	
	draw_sprite(bImage, turret->bImage, 0, 0);
	rotate_sprite(bImage, gun->bImage, 0, 0, itofix((int)angle/1.40625));
	//draw_sprite(bImage, gun->bImage, 0, 0);
}


void CART::increase_speed(double value)
{
	if(abs(system_time - engine_delay) > 1)
	{		
		if(engine_speed < max_speed)
			engine_speed += value;		
		engine_delay = system_time;
	}
}

void CART::decrease_speed(double value)
{
	if(abs(system_time - engine_delay) > 1)
	{		
		if(engine_speed < max_speed)
			engine_speed -= value;		
		engine_delay = system_time;
	}
}

void CART::stabalize()
{
	if(abs(system_time - engine_delay) > 1)
	{
		engine_delay = system_time;		
		if(engine_speed == 0.0)
			return;
		
		if(engine_speed > 0.0)
			engine_speed -= 0.05;
		else
			engine_speed += 0.05;

		if(engine_speed < 0.6 && engine_speed > -0.6)
			engine_speed = 0;

		
	}
}
