#include <stdio.h>
#include <allegro.h>
#include "mappyal.h"
#include "sprite.h"
#include "game.h"
#include "overworld.h"
#include "allegro_color.h"
#include "alogg.h"

//#define MODE GFX_AUTODETECT_FULLSCREEN
#define MODE GFX_AUTODETECT_WINDOWED
#define GFX_W 640
#define GFX_H 480
#define TILE_H 32
#define MAX_AIR 35
#define AIR 10
#define GROUND MAX_AIR + 1



void timer1(void)
{
	counter++;
	framerate = ticks;
	ticks = 0;
	rest(2);
}END_OF_FUNCTION(timer1);

void timer2(void)
{
	system_time++;	
}END_OF_FUNCTION(timer2);

void init();
void ascii_art();

#define MAX_ART 1000

int main(void)
{
	int select = 0, i = 0;
	FILE *fOgg;
	ALOGG_OGG *music;
	char *data;
	bool quit = false;
	int len;
	int cASC[MAX_ART];
	int iASC[MAX_ART], iASCX[MAX_ART], iASCY[MAX_ART];
	OVERWORLD gameworld;
	BITMAP *bText;
	init();

	for(i = 0; i < MAX_ART; i++)
		iASC[i] = 0;
	

	
	len = (int)file_size("Mystery.ogg");
	data = new char[len];
    fOgg = fopen("Mystery.ogg", "r");
	fread(data, 1, len, fOgg);
	if(!fOgg) allegro_message("uh oh...");	
	
	music = alogg_create_ogg_from_buffer(data, len);
	if(music == NULL)
		allegro_message("death");

	alogg_play_ex_ogg(music, 65536, 255, 127, 1000, 1);
	alogg_start_autopoll_ogg(music, 25);

	buffer = create_bitmap(GFX_W, GFX_H);
	bText = create_bitmap(GFX_W, GFX_H);
	ascii_art();

	
	select = 0;
	// Menu Game Loop
	while(!key[KEY_ESC] && quit == false)
	{
		rectfill(buffer, 0, 0, buffer->w, buffer->h, BLACK);
		rectfill(bText, 0, 0, bText->w, bText->h, MASK);
		
		for(i = 0; i < MAX_ART; i++)
		{
			if(iASC[i] == 0 && rand() % 50 > 25)
			{
				cASC[i] = rand() % 250 + 50;
				iASCX[i] = rand() % SCREEN_W;
				iASCY[i] = rand() % SCREEN_H;
				iASC[i] = 1;
			}
			if(iASC[i] != 0)
			{
				textprintf(bText, font, iASCX[i], --iASCY[i], GREEN, "%c", cASC[i]);
				if(iASCY[i] < 0)
					iASC[i] = 0;
			}
		}

		//Do Menu stuff
		//...
		// Out of time...in other words, it's crappy menu time!		
		textprintf(bText, font, 250, 180, WHITE, "Fragments of Time");
		textprintf(bText, font, 250, 190, WHITE,"  Alpha Stages");

		if (select == 0) textprintf(bText, font, 250, 230, RED, "Select a Map to Play");
		else textprintf(bText, font, 250, 230, WHITE, "Select a Map to Play");
		if (select == 1) textprintf(bText, font, 250, 240, RED, "Credits");
		else textprintf(bText, font, 250, 240, WHITE, "Credits");
		if (select == 2) textprintf(bText, font, 250, 250, RED, "Quit");
		else textprintf(bText, font, 250, 250, WHITE, "Quit");		

		if(key[KEY_DOWN])
		{
			while(key[KEY_DOWN]){}
			select++;
			if(select == 3)
				select = 0;
		}
		if(key[KEY_UP])
		{
			while(key[KEY_UP]){}
			select--;
			if(select == -1)
				select = 2;
		}

		if(key[KEY_ENTER])
		{
			while(key[KEY_ENTER]){}
			if(select == 0)
			{
				clear(bText);
				while(!key[KEY_ESC])
				{
					rectfill(buffer, 0, 0, buffer->w, buffer->h, BLACK);
					rectfill(bText, 0, 0, bText->w, bText->h, MASK);
		
					textprintf(bText, font, 250, 180, WHITE, "Fragments of Time");
					textprintf(bText, font, 250, 190, WHITE,"  Alpha Stages");

					if (select == 0) textprintf(bText, font, 250, 230, RED, "Test Map");
					else textprintf(bText, font, 250, 230, WHITE, "Test Map");
					if (select == 1) textprintf(bText, font, 250, 240, RED, "Level1");
					else textprintf(bText, font, 250, 240, WHITE, "Level1");
					//if (select == 2) textprintf(bText, font, 0, 0, RED, "Quit");
					//else textprintf(bText, font, 0, 0, WHITE, "Quit");		

					if(key[KEY_DOWN])
					{
						while(key[KEY_DOWN]){}
						select++;
						if(select == 2)
							select = 0;
					}
					if(key[KEY_UP])
					{
						while(key[KEY_UP]){}
						select--;
						if(select == -1)
							select = 1;
					}


					if(key[KEY_ENTER])
					{
						alogg_stop_ogg(music);
						if(select == 0)
                            gameworld.main_loop("test.fmp");		
						else
							gameworld.main_loop("level1.fmp");		
					}
					draw_sprite(buffer, bText, 0, 0);
					draw_sprite(screen, buffer, 0, 0);
					
						
				}
				while(key[KEY_ESC]);
			}
			if(select == 2)
				quit = true;
		}		

		draw_sprite(buffer, bText, 0, 0);
		//draw_sprite(buffer, bText, 320, 240);
		draw_sprite(screen, buffer, 0, 0);		

		//For now, skip to overworld for testing
		

	}

	destroy_bitmap(bText);
	destroy_bitmap(buffer);
	alogg_destroy_ogg(music);
	delete data;
	fclose(fOgg);
	
	allegro_exit();

	return 0;
}
END_OF_MAIN();

void ascii_art()
{

}

void init()
{
	//  Allegro Library
	if(allegro_init() != 0)
	{
		allegro_message("ERROR:  Failed to initialize allegro library.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}

	set_color_depth(24) ; // 24 bit colour	
	if (set_gfx_mode(MODE, GFX_W, GFX_H, 0, 0)<0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("ERROR:  Failure to init video mode!  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	

	//  Install Keyboard	
	if(install_timer() != 0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("ERROR:  Failed to install timer.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	


	//  Install Keyboard	
	if(install_keyboard() != 0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("ERROR:  Failed to install keyboard.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}	

	//  Install Mouse
	if(install_mouse() < 0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("ERROR:  Failed to install mouse.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	
	text_mode(MASK);	
	reserve_voices(32,-1); ///Reserves more channels of sound for us
	
	//  Install Sound
	if(install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0)	
	{
		allegro_message("ERROR:  Failure to install sound.  Attempting to run without sound.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		if(install_sound(DIGI_NONE, MIDI_NONE, NULL) != 0)
		{
			allegro_message("ERROR:  Failed to install sound.  Terminating program.\n");
			allegro_message("REPORT:  %s\n", allegro_error);
			exit(0);
		}		
	}
	
	//srand(time(0));
	srand( (unsigned) time(NULL));
	
	// Install Time Handler
	LOCK_VARIABLE(counter);
	LOCK_VARIABLE(framerate);
	LOCK_VARIABLE(ticks);
	LOCK_VARIABLE(system_time);
	LOCK_FUNCTION(timer1);
	LOCK_FUNCTION(timer2);
	install_int(timer1, 1000);
	install_int_ex(timer2, MSEC_TO_TIMER(20));
	/*install_int_ex(TIMER_PROC, BPS_TO_TIMER(60));
	install_int_ex(GAME_TIMER_PROC, MSEC_TO_TIMER(1));
	LOCK_VARIABLE(timer);
	LOCK_VARIABLE(system_timer);
	LOCK_FUNCTION(TIMER_PROC);	
	LOCK_FUNCTION(GAME_TIMER_PROC);*/
	
}
