#ifndef _OVERWORLD_H_
#define _OVERWORLD_H_

#include "allegro.h"
#include "sprite.h"
#include "cart.h"
#include "bullet.h"
#include "enemy.h"
#include "dome.h"

#define MAX_BULLETS 50
#define MAX_ENEMIES 10

//Singleton Class
class OVERWORLD
{
public:
	bool key_flag;
	int mapxoff, mapyoff;
	CART *unit;
	int block_count;
	int current_x, current_y;
	int block_x, block_y;
	int x_stamp, y_stamp;
	bool backwards;
	bool forwards;
	BULLET *bBullets[MAX_BULLETS];
	int bullet_count;
	int max_bullets;
	int gun_type;
	int fire_delay;
	ENEMY *eEnemies[MAX_ENEMIES];	
	DOME *dDomes[MAX_DOMES];
	int score;
	int score_delay;
	int game_time;
	

	BITMAP *bGUI;
	BITMAP *bFace;

	OVERWORLD();
	~OVERWORLD();

	void main_loop(char *path);
	

private:
	void draw();
	void DrawGUI();
	void DrawDebug();
	void input();
	void movement();
	void turn_cart();

	void GameOver();
	void help_menu();
	void smooth_shooting();
	void quick_shooting();

	void UpdateBullets();
	void UpdateEnemies();
	bool UpdateDomes();
	void UpdateScore();
	int dist(int x1, int y1, int x2, int y2);



	//int collided(DIRECTION dir, int x, int y);

};

#endif /* _OVERWORLD_H_ */